#include "idea.c"

int main(int argc, char **argv)
{ 
	int i;
	struct idea_context *enc, *dec;
	
	enc = idea_context_new();
	dec = idea_context_new();
	
	u_int16_t text[]={
		0x0000, 0x0001, 0x0002, 0x0003,
	};
	u_int16_t test_key[]={
		0x0001, 0x0002, 0x0003, 0x0004,
		0x0005, 0x0006, 0x0007, 0x0008,
	}; 
	/*------SET NEW CONTEXTs for enryprion and decryption------*/
	idea_get_key(test_key, enc);
	idea_get_key(test_key, dec);
		
	memcpy(enc->block, text, sizeof(text));
	
	/*-----------ENCRYPTION-------------*/
	printf("\nBEFORE SCRAMBLING\n");
	for(i=0;i<4;i++)
		printf("bloc[%d] = %x ", i, enc->block[i]);
	
	idea_scrambling(enc);
	
	printf("\nAFTER SCRAMBLING\n");
	for(i=0;i<4;i++)
		printf("bloc[%d] = %x ", i, enc->block[i]);
	
	/*-----------DECRYPTION-------------*/
	memcpy(dec->block, enc->block, sizeof(text));
	idea_invertkey(dec);
	
	
	printf("\nBEFORE SCRAMBLING\n");
	for(i=0;i<4;i++)
		printf("bloc[%d] = %x ", i, dec->block[i]);
	
	idea_scrambling(dec);
	
	printf("\nAFTER SCRAMBLING\n");
	for(i=0;i<4;i++)
		printf("bloc[%d] = %x ", i, dec->block[i]);
	printf("\n");

	/*-------------FINISH---------------*/
	idea_context_free(&enc);
	idea_context_free(&dec);
	
	return 0;
} 
